#lang racket/gui

;;; scroll-fac-gui.rkt - Les barres de defilement sont automatiques (PCPS exercice 14.5.4 page 338)
;;; Chapitre 14 (Objets et API graphique)
;;; Racket 6.6

"INTERFACE GRAPHIQUE : LA FACTORIELLE AVEC SCROLLING HORIZONTAL"

(define FRAME 
  (new frame% 
       (label "Factorielle")
       (x 500) (y 200)    ; position du coin haut gauche de la fenetre...
       (stretchable-height #f)))

(define VPANEL 
  (new vertical-panel% 
       (parent FRAME) 
       (alignment '(left center))))

(define (fac n)
  (apply * (build-list n add1)))

(define (update-result n)
  (send TEXT lock #f)
  (send TEXT erase)
  (send TEXT insert (number->string (fac n)))
  (send TEXT lock #t))

(define TEXT-FIELD 
  (new text-field% 
       (parent VPANEL)
       (min-width 300)
       (stretchable-width #f)
       (label "Donnez la valeur de n : ")
       (init-value "0")
       (callback (lambda (obj evt)
                   (when (equal? (send evt get-event-type) 'text-field-enter)
                     (update-result (string->number (send TEXT-FIELD get-value))))))))

(define TEXT (new text%))
(send TEXT lock #t)           ; verrouillage en ecriture
(send TEXT hide-caret #t)     ; cacher le curseur clavier

(define ECANVAS 
  (new editor-canvas% 
       (parent FRAME) 
       (min-height 50) 
       (editor TEXT)))

(send TEXT insert "1")

(define HPANEL 
  (new horizontal-panel% 
       (parent VPANEL) 
       (alignment '(center center))))

(define BOUTON 
  (new button% 
       (parent HPANEL) 
       (label "Random")
       ;(style '(border))     ; careful : this captures the text-field-enter event in the text-field component !
       (callback (lambda (obj evt)
                   (define n (+ 2 (random 40)))
                   (send TEXT-FIELD set-value (number->string n))
                   (update-result n)))))

(send FRAME show #t)
